
package weaver.interfaces.oml.action;

import com.engine.kq.biz.KQGroupMemberComInfo;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * 系统验证数据是否超过可申请时长Action
 */
public class CheckNeewTimeAction implements Action {
    public CheckNeewTimeAction() {
    }

    @Override
    public String execute(RequestInfo info) {
        new BaseBean();
        BaseBean bb = new BaseBean();
        bb.writeLog("系统验证数据是否超过可申请时长Action");
        RecordSet rs = new RecordSet();
        int userid = info.getRequestManager().getUser().getUID();
        try {
            //获取主表数据
            Map mainInfo = getMainInfo(info);
            //申请月份
            String sqyf = Util.null2String(mainInfo.get("sqyf"));
            String sqyfNew = sqyf +"-01";
            String sqyfEnd = sqyf + "-31";
            String jbzsc = Util.null2String(mainInfo.get("jbzsc"));
            String jbry = Util.null2String(mainInfo.get("jbry"));
            bb.writeLog("jbry"+jbry);
            userid = Integer.valueOf(jbry);
            bb.writeLog("userid"+userid);


            /*获取考勤组的ID，因为考勤组有有效期，所以需要传入日期*/
            KQGroupMemberComInfo kqGroupMemberComInfo = new KQGroupMemberComInfo();
            String groupId = kqGroupMemberComInfo.getKQGroupId(String.valueOf(userid), sqyfNew);
            bb.writeLog("groupId:"+groupId);

            if (StringUtils.isBlank(groupId)){
                info.getRequestManager().setMessageid("2000");
                info.getRequestManager().setMessagecontent("请为该人员添加考勤组");
                return Action.FAILURE_AND_CONTINUE;
            }

//            String  fromDate = TimeUtil.getDateByOption("3","0");
//            String toDate = TimeUtil.getDateByOption("3","1");
            String  fromDate = sqyfNew;
            String toDate = sqyfEnd;
            String sql = "select sum(attendancemins) as workmins,sum(leaveMins) as leaveMins from kq_format_detail where kqdate >= '"+fromDate+"' and kqdate <= '"+toDate+"' and resourceid = "+userid;
            rs.execute(sql);
            bb.writeLog("sql:"+sql);
            String attendancemins = "";
            String workmins = "";
            Integer workdays = 0;
            String leaveMins = "";
            if (rs.next()){
                workmins = Util.null2String(rs.getString("workmins"));
//                workdays = Util.null2String(rs.getString("workdays"));
                leaveMins = Util.null2String(rs.getString("leaveMins"));
            }
            workmins = StringUtils.isBlank(workmins)?"0":workmins;
            leaveMins = StringUtils.isBlank(leaveMins)?"0":leaveMins;
            bb.writeLog("workmins:"+workmins+"leaveMins:"+leaveMins);
            //当月加班时长
            String jbTime = getOverTime(fromDate,toDate,userid);
            bb.writeLog("jbTime:"+jbTime);
            //当月事假时长
            String sjMonthTime = getSjTime(fromDate,toDate,userid,"2");
            //当月探亲事假时长
            String tqsj = bb.getPropValue("omlKq_main","tqsj");
            bb.writeLog("tqsj:"+tqsj);
            String tqsjMonthTime = getSjTime(fromDate,toDate,userid,tqsj);
            //当月实际工作时长
            Integer sjTime = Integer.valueOf(workmins)+Integer.valueOf(leaveMins)-(Integer.valueOf(sjMonthTime))-(Integer.valueOf(tqsjMonthTime)) + Integer.valueOf(jbTime);
            bb.writeLog("jbTime:"+jbTime+"sjTime:"+sjTime+"sjMonthTime:"+sjMonthTime+"tqsjMonthTime:"+tqsjMonthTime);
            String type = "";
            //非B C类员工
            //当月应出勤时长
            Integer ycqTime = 0;
            //标准行事历休息天数
            String bzxsl = bb.getPropValue("omlKq_main","bzxsl");
            bb.writeLog("bzxsl:"+bzxsl);
            String xxDay = getXxDay(fromDate,toDate,Integer.valueOf(bzxsl));
            //员工所在行事历休息天数
//            String ygszDay = getXxDay(fromDate,toDate,Integer.valueOf(groupId));
            SimpleDateFormat df  = new SimpleDateFormat("yyyy-MM-dd");
            //当月总天数
            Integer thisMonthDay = getDaysOfMonth(df.parse(sqyfNew));
            workdays = thisMonthDay - Integer.valueOf(xxDay);
            type = getField9(userid);

            if ("1".equals(type)){
                ycqTime = workdays*8;
            }else if ("2".equals(type)){
                ycqTime = workdays*8;
            }else{
                ycqTime =  workdays*8;
            }
            Integer ycqTimeGy = workdays*8;
            bb.writeLog("ycqTime:"+ycqTime+"sjTime:"+sjTime);

            Integer needTime = 0;
            if ("1".equals(type)){
                needTime = sjTime - (ycqTimeGy*60) - (20*60);
            }else if ("2".equals(type)){
                needTime = sjTime - (ycqTimeGy*60) -(36*60);
            }else{
                needTime =  sjTime - (ycqTime*60);
            }
            String jbzscNew = multiply(jbzsc,"60");
            Double needTimeHour = divide(String.valueOf(needTime),"60");
            bb.writeLog("jbzscNew:"+jbzscNew+"needTime:"+needTime+" needTimeHour:"+needTimeHour);
            if (needTime<0){
                info.getRequestManager().setMessageid("2000");
                info.getRequestManager().setMessagecontent("无加班时长可申请");
                return Action.FAILURE_AND_CONTINUE;
            }else{
//                if (Double.valueOf(jbzscNew)>needTime){
//                    info.getRequestManager().setMessageid("2000");
//                    info.getRequestManager().setMessagecontent("超过可申请时长");
//                    return Action.FAILURE_AND_CONTINUE;
//                }
                if ( Double.valueOf(jbzsc) > needTimeHour ){
                    info.getRequestManager().setMessageid("2000");
                    info.getRequestManager().setMessagecontent("超过可申请时长");
                    return Action.FAILURE_AND_CONTINUE;
                }
            }

            bb.writeLog("attendancemins:"+attendancemins+"workmins:"+workmins);

        } catch (Exception e) {
            e.printStackTrace();
            bb.writeLog(e);
            bb.writeLog("系统验证数据是否超过可申请时长error"+e.getMessage());
            info.getRequestManager().setMessageid("2000");
            info.getRequestManager().setMessagecontent("系统验证数据是否超过可申请时长error");
            return Action.FAILURE_AND_CONTINUE;
        }
        return Action.SUCCESS;
    }

    /**
     * 提供精确的除法运算。
     * @param v1 被加数
     * @param v2 加数
     * @return 两个参数的和
     */
    public static Double divide(String v1, String v2) {
        BigDecimal b1 = new BigDecimal(v1);
        BigDecimal b2 = new BigDecimal(v2);
        return b1.divide(b2,2,BigDecimal.ROUND_HALF_UP).doubleValue();
    }

    /**
     * 获取本月的天数
     * @param date
     * @return
     */
    public static int getDaysOfMonth(Date date) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        return calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
    }


    /**
     * 获取主表数据
     *
     * @param requestInfo
     * @return
     */
    private static Map getMainInfo(RequestInfo requestInfo) {
        Map map = new HashMap();
        Property[] property = requestInfo.getMainTableInfo().getProperty();
        for (int i = 0; i < property.length; i++) {
            map.put(property[i].getName().toLowerCase(), Util.null2String(property[i].getValue()));
        }
        return map;
    }

    /**
     * 获取当月加班时间（不包含节假日）
     * @param startTime
     * @param endTime
     * @return
     */
    private static String getOverTime(String startTime,String endTime,Integer resourceid){
        RecordSet rs = new RecordSet();
        String sql = "select sum(duration_min) as duration_min from KQ_FLOW_OVERTIME where belongdate >= '"+startTime+"' and belongdate <= '"+endTime+"' and changetype = 3 and resourceid = "+resourceid;
        rs.executeQuery(sql);
        BaseBean basebean = new BaseBean();
        basebean.writeLog("getOverTime sql:" + sql);
        String 	duration_min = "";
        if (rs.next()){
            duration_min = Util.null2String(rs.getString("duration_min"));
        }
        if (StringUtils.isBlank(duration_min)){
            duration_min = "0";
        }
        return duration_min;
    }

    /**
     * 获取当月事假时间（不包含节假日）
     * @param startTime
     * @param endTime
     * @return
     */
    private static String getSjTime(String startTime,String endTime,Integer resourceid,String type){
        RecordSet rs = new RecordSet();
        String sql = "select sum(d_mins) as leaveMins from  kq_flow_split_leave where newleavetype = '"+type+"' and  belongdate >= '"+startTime+"' and belongdate <= '"+endTime+"' and leavebackrequestid is null  and resourceid = "+resourceid;
        rs.executeQuery(sql);
        String leaveMins = "";
        if (rs.next()){
            leaveMins = Util.null2String(rs.getString("leaveMins"));
        }
        if (StringUtils.isBlank(leaveMins)){
            leaveMins = "0";
        }
        return leaveMins;
    }

    /**
     * 获取当月休息日
     * @param startTime
     * @param endTime
     * @return
     */
    private static String getXxDay(String startTime,String endTime,Integer groupId){
        BaseBean bb = new BaseBean();
        RecordSet rs = new RecordSet();
        String sql = "select holidayDate from  KQ_HolidaySet where  holidayDate >= '"+startTime+"' and holidayDate <= '"+endTime+"' and changeType in (1,3)  and groupId = "+groupId;
        rs.executeQuery(sql);
        List<Object> holidayList1 = new ArrayList<Object>();
        while (rs.next()){
            String holidayDate = Util.null2String(rs.getString("holidayDate"));
            holidayList1.add(holidayDate);
        }
        String sql2 = "select holidayDate from  KQ_HolidaySet where  holidayDate >= '"+startTime+"' and holidayDate <= '"+endTime+"' and changeType in (2)  and groupId = "+groupId;
        rs.executeQuery(sql2);
        List<Object> holidayList2 = new ArrayList<Object>();
        while (rs.next()){
            String holidayDate = Util.null2String(rs.getString("holidayDate"));
            holidayList2.add(holidayDate);
        }

        //新增逻辑
        SimpleDateFormat df  = new SimpleDateFormat("yyyy-MM-dd");
        Calendar today = Calendar.getInstance();
        try {
            today.clear();
            today.setTime(df.parse(startTime));
        } catch (ParseException e) {
            e.printStackTrace();
        }
        String currentYear =  "" + today.get(Calendar.YEAR);
        String currentMonth = "" + today.get(Calendar.MONTH);
        Calendar dateTemp = Calendar.getInstance();
        Integer all = 0;
        for (int j = 1; j <= 31; j++) {
            dateTemp.clear();
            dateTemp.set(Integer.valueOf(currentYear),Integer.valueOf(currentMonth),j);
            if (dateTemp.get(Calendar.MONTH) != Integer.valueOf(currentMonth)) {//防止出现2月30号等错误日期参数
                continue;
            }
            String dateStr = Util.add0(dateTemp.get(Calendar.YEAR), 4) + "-" +
                    Util.add0(dateTemp.get(Calendar.MONTH) + 1, 2) + "-" +
                    Util.add0(dateTemp.get(Calendar.DAY_OF_MONTH), 2);
            if (holidayList1.contains(dateStr)) {
                all++;
            }else if(dateTemp.getTime().getDay() == 6 || dateTemp.getTime().getDay() == 0){
                if(!holidayList2.contains(dateStr)){
                    all++;
                }
            }
        }
        bb.writeLog("总休息天数:"+all);
        return String.valueOf(all);
    }

    /**
     * 判断员工类型
     * @param userid
     * @return
     */
    private static String getField9(Integer userid){
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        String yglx = bb.getPropValue("omlKq_main","yglx");
        bb.writeLog("yglx:"+yglx);
        String sql = "select "+yglx+" from cus_fielddata where id = "+userid+" and scope = 'HrmCustomFieldByInfoType' and scopeid = -1";
        rs.executeQuery(sql);
        String 	field9 = "";
        if (rs.next()){
            field9 = Util.null2String(rs.getString(yglx));
        }
        return field9;
    }

    /**
     * 提供精确的乘法运算。
     * @param v1 被加数
     * @param v2 加数
     * @return 两个参数的和
     */
    public static String multiply(String v1, String v2) {
        BigDecimal b1 = new BigDecimal(v1);
        BigDecimal b2 = new BigDecimal(v2);
        return b1.multiply(b2).toString();
    }


    public static void main(String[] args) {
        HashSet<String> persons = new HashSet<>();
        persons.add("123");
        persons.add("321");
        persons.add("123");
        if (persons.contains("123")){
            System.out.println("kkk");
        }
        System.out.println(StringUtils.join(persons,","));
    }

}
