package weaver.interfaces.oml.action;

import com.engine.kq.biz.KQGroupMemberComInfo;
import com.engine.kq.biz.KQWorkTime;
import com.engine.kq.entity.WorkTimeEntity;
import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.formmode.setup.ModeRightInfo;
import weaver.general.BaseBean;
import weaver.general.TimeUtil;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created with IntelliJ IDEA.
 * 综合工时制员工月度加班工时更新(上个月)
 * @Auther: chenxu
 * @Date: 2023/02/27/14:03
 * @Description:
 */
public class KqResetZhLastMonthEveryDay extends BaseCronJob {

    @Override
    public void execute() {
        new BaseBean();
        BaseBean bb = new BaseBean();
        bb.writeLog("综合工时制员工月度加班工时更新上个月！！！");
        RecordSet rs = new RecordSet();
        RecordSet rs1 = new RecordSet();
        RecordSet rsUpdate1 = new RecordSet();

        String fromDate = TimeUtil.getLastMonthBeginDay();
        String toDate = TimeUtil.getLastMonthEndDay();
        bb.writeLog("fromDate:"+fromDate+"toDate:"+toDate);
        String dateMonthSub = fromDate.substring(0,7);
        bb.writeLog("dateMonthSub:"+dateMonthSub);
        try {
           String sql = "select id,departmentid,subcompanyid1 from hrmresource where status<>5 ";
           rs.executeQuery(sql);
           while (rs.next()){
               String id = Util.null2String(rs.getString("id"));
               String departmentid = Util.null2String(rs.getString("departmentid"));
               String subcompanyid1 = Util.null2String(rs.getString("subcompanyid1"));

               /*获取考勤组的ID，因为考勤组有有效期，所以需要传入日期*/
               KQGroupMemberComInfo kqGroupMemberComInfo = new KQGroupMemberComInfo();
               String groupId = kqGroupMemberComInfo.getKQGroupId(id, fromDate);
               bb.writeLog("groupId:"+groupId);
               String groupidZh = bb.getPropValue("omlKq_main","groupidZh");
               bb.writeLog("groupidZh:"+groupidZh);
               //该员工为综合工时制考勤组
               if (Arrays.asList(groupidZh.split(",")).contains(groupId)){
                   try {
                       //标准行事历休息天数
                       String bzxsl = bb.getPropValue("omlKq_main","bzxsl");
                       String xxDay = getXxDay(fromDate,toDate,Integer.valueOf(bzxsl));
                       bb.writeLog("departmentid:"+departmentid+"subcompanyid1:"+subcompanyid1);
//                   //员工所在行事历休息天数
//                   String ygszDay = getXxDay(fromDate,toDate,Integer.valueOf(groupId));
                       //实际出勤天数
//                       String workdaySj =  getSjWorkDay(fromDate,toDate,Integer.valueOf(id));
                       //当月应出勤时长
                       Integer ycqTime = 0;
                       Integer workdays = 0;
                       SimpleDateFormat df  = new SimpleDateFormat("yyyy-MM-dd");
                       //当月总天数
                       Integer thisMonthDay = getDaysOfMonth(df.parse(fromDate));
                       workdays = thisMonthDay - Integer.valueOf(xxDay);

                       //月实出勤时数，月应出勤时数更新逻辑
                       String sqlMonth = "select sum(attendancemins) as workmins,sum(leaveMins) as leaveMins from kq_format_detail where kqdate >= '"+fromDate+"' and kqdate <= '"+toDate+"' and resourceid = "+id;
                       rs1.execute(sqlMonth);
                       String workmins = "";
                       String leaveMins = "";
                       if (rs1.next()){
                           workmins = Util.null2String(rs1.getString("workmins"));
                           leaveMins = Util.null2String(rs1.getString("leaveMins"));
                       }
                       workmins = StringUtils.isBlank(workmins)?"0":workmins;
                       leaveMins = StringUtils.isBlank(leaveMins)?"0":leaveMins;
                       bb.writeLog("workmins:"+workmins+"leaveMins:"+leaveMins);
                       //当月加班时长
                       String jbTime = getOverTime(fromDate,toDate,Integer.valueOf(id));
                       //当月事假时长
                       String sjMonthTime = getSjTime(fromDate,toDate,Integer.valueOf(id),"2");
                       //当月探亲事假时长
                       String tqsj = bb.getPropValue("omlKq_main","tqsj");
                       bb.writeLog("tqsj:"+tqsj);
                       String tqsjMonthTime = getSjTime(fromDate,toDate,Integer.valueOf(id),tqsj);
                       //当月实际工作时长
                       Integer sjTime = Integer.valueOf(workmins)+Integer.valueOf(leaveMins)-Integer.valueOf(tqsjMonthTime);
                       bb.writeLog("jbTime:"+jbTime+"sjTime:"+sjTime+"sjMonthTime:"+sjMonthTime);
                       ycqTime =  workdays*8;
                       bb.writeLog("ycqTime:"+ycqTime+"sjTime:"+sjTime);

                       //事假时间
                       Integer sjTimeNew = (ycqTime*60) - sjTime;
                       bb.writeLog("sjTimeNew:"+sjTimeNew);
                       String dybzgzsjid = bb.getPropValue("omlKq_main","dybzgzsjid");
                       //高于标准工作时间
                       String gybzgzsjid = bb.getPropValue("omlKq_main","gybzgzsjid");
                       //为负数，计入低于标准工作时间
                       if (sjTimeNew > 0){
                           String sqlCqSj = "update kq_flow_split_leave set duration = 0 where belongdate >= '"+fromDate+"' and belongdate <= '"+toDate+"' and newleavetype in ("+dybzgzsjid+","+gybzgzsjid+")  and resourceid = "+Integer.valueOf(id);
                           bb.writeLog("sqlCqSj:"+sqlCqSj);
                           rsUpdate1.executeUpdate(sqlCqSj);
                           bb.writeLog("插入标准时间");
                           Double sjTimeHours = divide(String.valueOf(sjTimeNew),"60");
                           bb.writeLog("sjTimeHours:"+sjTimeHours);
                           insertLeave("",Integer.valueOf(id),fromDate,sjTimeHours,"3",dybzgzsjid,subcompanyid1,departmentid);
                       }else{
                           String sqlCqSj = "update kq_flow_split_leave set duration = 0 where belongdate >= '"+fromDate+"' and belongdate <= '"+toDate+"' and newleavetype in ("+dybzgzsjid+","+gybzgzsjid+")  and resourceid = "+Integer.valueOf(id);
                           bb.writeLog("sqlCqSj:"+sqlCqSj);
                           rsUpdate1.executeUpdate(sqlCqSj);
                           Integer gyTimes = sjTime - (ycqTime*60);
                           Double gyTimeHours = divide(String.valueOf(gyTimes),"60");
                           bb.writeLog("插入高于标准工作时间gyTimes:"+gyTimeHours);
                           insertLeave("",Integer.valueOf(id),fromDate,gyTimeHours,"3",gybzgzsjid,subcompanyid1,departmentid);
                       }
                       bb.writeLog("workdays:"+workdays);
                       Integer xxdayByYg = getShiftSchedule(groupId,id,fromDate,toDate);
                       bb.writeLog("xxdayByYg:"+xxdayByYg);

//                       Integer needTime = (int) Math.floor(Double.valueOf(workdaySj)) - Integer.valueOf(workdays);
                       Integer needTime =  Integer.valueOf(xxDay) - xxdayByYg;
                       bb.writeLog("xxDay:"+xxDay+"needTime:"+needTime);
                       //当月加班时间
                       String jbzsc = getOverTime(fromDate,toDate,Integer.valueOf(id));
                       bb.writeLog("jbzsc:"+jbzsc);
                       Integer jbTimes = sjTime - ycqTime*60;
                       bb.writeLog("jbTimes:"+jbTimes);
                       if (jbTimes>0){
                           Integer sjTimeN = sjTime;
                           bb.writeLog("sjTimeN:"+sjTimeN);
                           jbTimes = sjTimeN - ycqTime*60;
//                           Integer newsjTimes = ycqTime*60 - Integer.valueOf(leaveMins);
                           if (needTime>0){
                               //最多双休小时数
                               Integer MaxHours = 0;
                               Integer xsMax = needTime*8*60;
                               if (jbTimes>xsMax){
                                   MaxHours = xsMax;
                               }else{
                                   MaxHours = jbTimes;
                               }

                               //平时加班小时数
                               Integer PsHours = 0;
                               if (jbTimes>xsMax){
                                   PsHours = jbTimes - MaxHours;
                               }else{
                                   PsHours = 0;
                               }
                               bb.writeLog("MaxHours:"+MaxHours+"PsHours:"+PsHours);
                               if(MaxHours>=0 && PsHours>=0){
                                   //原加班时间清零
//                                   RecordSet rsUpdateJb = new RecordSet();
//                                   String sqlUpdate = "update KQ_FLOW_OVERTIME set duration_min=0 where belongdate >= '"+fromDate+"' and changetype <> 1 and belongdate <= '"+toDate+"' and resourceid = "+id;
//                                   bb.writeLog("updateSql:"+sqlUpdate);
//                                   rsUpdateJb.executeUpdate(sqlUpdate);
//                                   insertOverTime("",id,fromDate,MaxHours,"3");
//                                   insertOverTime("",id,fromDate,PsHours,"2");
                                   if(checkUfKq(id,dateMonthSub)){
                                       //更新
                                       RecordSet rsUpdateSub = new RecordSet();
                                       String sqlSub = "update uf_ydjbtz set psjb = "+PsHours+",sxjb ="+MaxHours+" where kqny  = '"+dateMonthSub+"' and xm = "+Integer.valueOf(id);
                                       bb.writeLog("sqlSub:"+sqlSub);
                                       rsUpdateSub.executeUpdate(sqlSub);
                                   }else{
                                       //插入
                                       insertKqUf(id,dateMonthSub,PsHours,MaxHours,0,0);
                                   }
                               }
                           }else{
                               Integer PsHours = jbTimes;
                               if(PsHours>=0){
                                   //原加班时间清零
//                                   RecordSet rsUpdateJb = new RecordSet();
//                                   String sqlUpdate = "update KQ_FLOW_OVERTIME set duration_min=0 where belongdate >= '"+fromDate+"' and changetype <> 1 and belongdate <= '"+toDate+"' and resourceid = "+id;
//                                   bb.writeLog("updateSql:"+sqlUpdate);
//                                   rsUpdateJb.executeUpdate(sqlUpdate);
//                                   insertOverTime("",id,fromDate,PsHours,"2");
                                   if(checkUfKq(id,dateMonthSub)){
                                       //更新
                                       RecordSet rsUpdateSub = new RecordSet();
                                       String sqlSub = "update uf_ydjbtz set psjb = "+PsHours+",sxjb = 0 where kqny  = '"+dateMonthSub+"' and xm = "+Integer.valueOf(id);
                                       bb.writeLog("sqlSub:"+sqlSub);
                                       rsUpdateSub.executeUpdate(sqlSub);
                                   }else{
                                       //插入
                                       insertKqUf(id,dateMonthSub,PsHours,0,0,0);
                                   }
                               }
                           }
                           //原应出勤和实际出勤时数清零
                           bb.writeLog("原应出勤和实际出勤时数清零1");
                           RecordSet rsUpdate = new RecordSet();
                           String sqlCq = "update kq_format_total set workmins = 0,attendancemins =0,workdays=0 where kqdate >= '"+fromDate+"' and kqdate <= '"+toDate+"' and resourceid = "+Integer.valueOf(id);
                           bb.writeLog("sqlCq:"+sqlCq);
                           rsUpdate.executeUpdate(sqlCq);
                           if (checkNew(id,fromDate)){
                               bb.writeLog("原应出勤和实际出勤时数更新");
                               RecordSet rsUpdateNew = new RecordSet();
                               Integer ycqTimes = ycqTime*60;
                               String sqlCqNew = "update kq_format_total set workmins = "+ycqTimes+",attendancemins ="+sjTime+",workdays="+workdays+" where kqdate = '"+fromDate+"' and resourceid = "+Integer.valueOf(id);
                               bb.writeLog("sqlCqNew:"+sqlCqNew);
                               rsUpdateNew.executeUpdate(sqlCqNew);
                           }else{
                               bb.writeLog("原应出勤和实际出勤时数插入");
                               insertKqTotal(Integer.valueOf(id),fromDate,ycqTime*60,groupId,sjTime,workdays);
                           }
                       }else{
                           //原应出勤和实际出勤时数清零
                           bb.writeLog("原应出勤和实际出勤时数清零2");
                           RecordSet rsUpdate = new RecordSet();
                           String sqlCq = "update kq_format_total set workmins = 0,attendancemins =0,workdays=0 where kqdate >= '"+fromDate+"' and kqdate <= '"+toDate+"' and resourceid = "+Integer.valueOf(id);
                           bb.writeLog("sqlCq:"+sqlCq);
                           rsUpdate.executeUpdate(sqlCq);
                           if (checkNew(id,fromDate)){
                               bb.writeLog("原应出勤和实际出勤时数更新");
                               RecordSet rsUpdateNew = new RecordSet();
                               Integer ycqTimes = ycqTime*60;
                               String sqlCqNew = "update kq_format_total set workmins = "+ycqTimes+",attendancemins ="+sjTime+",workdays="+workdays+" where kqdate = '"+fromDate+"' and resourceid = "+Integer.valueOf(id);
                               bb.writeLog("sqlCqNew:"+sqlCqNew);
                               rsUpdateNew.executeUpdate(sqlCqNew);
                           }else{
                               bb.writeLog("原应出勤和实际出勤时数插入");
                               insertKqTotal(Integer.valueOf(id),fromDate,ycqTime*60,groupId,sjTime,workdays);
                           }
                           //增加清除平时加班，双休加班的处理
                           if(checkUfKq(id,dateMonthSub)){
                               //更新
                               RecordSet rsUpdateSub = new RecordSet();
                               String sqlSub = "update uf_ydjbtz set psjb = 0,sxjb = 0 where kqny  = '"+dateMonthSub+"' and xm = "+Integer.valueOf(id);
                               bb.writeLog("sqlSub:"+sqlSub);
                               rsUpdateSub.executeUpdate(sqlSub);
                           }else{
                               //插入
                               insertKqUf(id,dateMonthSub,0,0,0,0);
                           }
                       }
                   } catch (NumberFormatException e) {
                       bb.writeLog("numberError:"+e.getMessage());
                       e.printStackTrace();
                   } catch (ParseException e) {
                       bb.writeLog("error:"+e.getMessage());
                       e.printStackTrace();
                   }
               }
           }

        } catch (Exception e) {
            e.printStackTrace();
            bb.writeLog(e);
            bb.writeLog("综合工时制员工月度加班工时更新--error"+e.getMessage());
        }
    }

    /**
     * 判断是否存在当月的数据
     * @param resourceid
     * @param date
     * @return
     */
    private static Boolean checkUfKq(String resourceid,String date){
        RecordSet rs = new RecordSet();
        String sql = "select * from uf_ydjbtz where xm = "+resourceid+" and kqny  = '"+date+"'";
        rs.execute(sql);
        Boolean check = false;
        if (rs.getCounts()>0){
            check = true;
        }
        return check;
    }

    /**
     * 插入月度考勤报表
     * @param xm
     * @param kqny
     * @param psjb
     * @param sxjb
     * @param jjrjb
     * @param jbzdx
     */
    private static void insertKqUf(String xm,String kqny,Integer psjb,Integer sxjb,Integer jjrjb,Integer jbzdx){
        BaseBean bb  = new BaseBean();
        //插入加班时间
        RecordSet rsInsert = new RecordSet();
        int modeid = getFormModeIdByCubeName("uf_ydjbtz");
        SimpleDateFormat sdfDate = new SimpleDateFormat("yyyy-MM-dd");
        SimpleDateFormat sdfTime = new SimpleDateFormat("HH:mm:ss");
        String modedatacreatedate = sdfDate.format(new Date());
        String modedatacreatetime = sdfTime.format(new Date());
        String sql = "insert into uf_ydjbtz (xm,kqny,psjb,sxjb,jjrjb,jbzdx,FORMMODEID,MODEDATACREATER,MODEDATACREATERTYPE,MODEDATACREATEDATE,MODEDATACREATETIME) "
                + " values(?,?,?,?,?,?,?,?,?,?,?) ";
        rsInsert.executeUpdate(sql, xm,kqny,psjb,sxjb,jjrjb,jbzdx,modeid,xm,"0",modedatacreatedate,modedatacreatetime);
        bb.writeLog("insertSql:"+sql);
        RecordSet findNew = new RecordSet();
        String sqlFindnew ="select Id from uf_ydjbtz where xm = '"+xm+"' and kqny = '"+kqny+"' order by" +
                " modedatacreatedate desc,modedatacreatetime desc";
        findNew.execute(sqlFindnew);
        bb.writeLog("findSqlNew:"+sqlFindnew);
        String idNew = "1";
        if (findNew.next()){
            idNew = Util.null2String(findNew.getString("id"));
        }
        bb.writeLog("idNew:"+idNew);
        // 权限重构
        int dataId = Integer.valueOf(idNew);
        ModeRightInfo modeRightInfo = new ModeRightInfo();
        modeRightInfo.editModeDataShare(Integer.valueOf(xm), modeid, dataId);
    }

    /**
     * 根据建模表名获取formModeId
     *
     * @param cubeName 建模表明
     * @return int formModeId
     */
    private static int getFormModeIdByCubeName(String cubeName) {
        RecordSet rs = new RecordSet();
        rs.executeQuery("select t1.id from modeinfo t1\n" +
                " left join workflow_bill t2\n" +
                " on t1.formid=t2.id\n" +
                " where t2.tablename='" + cubeName + "'");
        rs.next();
        return rs.getInt("id");
    }

    /**
     * 根据员工班组获得休息日
     * @param groupid
     * @param resourceid
     * @param monthBeginDate
     * @param monthEndDate
     * @return
     */
    private Integer getShiftSchedule(String groupid, String resourceid, String monthBeginDate,String monthEndDate){
        Integer xxr = 0;
        String sql = "";
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        sql = "	select count(*) as xxr from kq_shiftschedule where groupid= '"+groupid+"' and resourceid="+resourceid+" " +
                "	and kqdate>='"+monthBeginDate+"' and kqdate<='"+monthEndDate+"' and (isdelete is null or  isdelete <> '1') and serialid = -1";
        bb.writeLog("sql getShiftSchedule:"+sql);
        rs.executeQuery(sql);
        if(rs.next()){
            xxr = rs.getInt("xxr");
        }
        return xxr;
    }

    /**
     * 提供精确的除法运算。
     * @param v1 被加数
     * @param v2 加数
     * @return 两个参数的和
     */
    public static Double divide(String v1, String v2) {
        BigDecimal b1 = new BigDecimal(v1);
        BigDecimal b2 = new BigDecimal(v2);
        return b1.divide(b2,2,BigDecimal.ROUND_HALF_UP).doubleValue();
    }

    /**
     * 基于主表获取实际工作时长
     * @param fromDate
     * @param toDate
     * @param id
     * @return
     */
    private static Integer getSjTimesNew(String fromDate,String toDate,Integer id){
        RecordSet rs1 = new RecordSet();
        BaseBean bb = new BaseBean();
        //月实出勤时数，月应出勤时数更新逻辑
        String sqlMonth = "select sum(attendancemins) as workmins,sum(leaveMins) as leaveMins from kq_format_total where kqdate >= '"+fromDate+"' and kqdate <= '"+toDate+"' and resourceid = "+id;
        rs1.execute(sqlMonth);
        String workmins = "";
        String leaveMins = "";
        if (rs1.next()){
            workmins = Util.null2String(rs1.getString("workmins"));
            leaveMins = Util.null2String(rs1.getString("leaveMins"));
        }
        workmins = StringUtils.isBlank(workmins)?"0":workmins;
        leaveMins = StringUtils.isBlank(leaveMins)?"0":leaveMins;
        bb.writeLog("workmins:"+workmins+"leaveMins:"+leaveMins);
        //当月加班时长
        String jbTime = getOverTime(fromDate,toDate,id);
        //当月探亲事假时长
        String tqsj = bb.getPropValue("omlKq_main","tqsj");
        bb.writeLog("tqsj:"+tqsj);
        String tqsjMonthTime = getSjTime(fromDate,toDate,Integer.valueOf(id),tqsj);
        //当月实际工作时长
        Integer sjTime = Integer.valueOf(workmins)+Integer.valueOf(leaveMins)-(Integer.valueOf(tqsjMonthTime));
        bb.writeLog("jbTime:"+jbTime+"sjTime:"+sjTime);
        return sjTime;
    }

    /**
     * 更新实际出勤时数
     * @param fromDate
     * @param sjTime
     * @param id
     */
    private static void updateBackTimes(String fromDate,Integer sjTime,Integer id){
        BaseBean bb = new BaseBean();
        bb.writeLog("实际出勤时数更新");
        RecordSet rsUpdateNew = new RecordSet();
        String sqlCqNew = "update kq_format_total set attendancemins ="+sjTime+" where kqdate = '"+fromDate+"' and resourceid = "+id;
        bb.writeLog("sqlCqNew:"+sqlCqNew);
        rsUpdateNew.executeUpdate(sqlCqNew);
    }

    /**
     * 获取当月实际工作天数
     * @param startTime
     * @param endTime
     * @return
     */
    private static String getSjWorkDay(String startTime,String endTime,Integer resourceid){
        RecordSet rs = new RecordSet();
        String sql = "select sum(attendancedays) as attendancedays from  kq_format_total where  kqdate >= '"+startTime+"' and kqdate <= '"+endTime+"'  and resourceid = "+resourceid;
        rs.executeQuery(sql);
        String 	attendancedays = "";
        if (rs.next()){
            attendancedays = Util.null2String(rs.getString("attendancedays"));
        }
        if (StringUtils.isBlank(attendancedays)){
            attendancedays = "0";
        }
        return attendancedays;
    }

    /**
     * 插入请假拆分表
     * @param requestid
     * @param userid
     * @param fromDate
     * @param MaxHours
     */
    private static void insertLeave(String requestid,Integer userid,String fromDate,Double MaxHours,String durationrule,String newleavetype,String subcompany,String department){
        BaseBean bb  = new BaseBean();
        //插入加班时间
        RecordSet rsInsert = new RecordSet();
        String sql = "insert into kq_flow_split_leave (requestid,resourceid,fromdate,fromtime,todate,totime,duration,durationrule,belongdate,newleavetype,subcompanyid,departmentid) "
                + " values(?,?,?,?,?,?,?,?,?,?,?,?) ";
        rsInsert.executeUpdate(sql, requestid,userid,fromDate,"07:30",fromDate,"18:00",MaxHours,durationrule,fromDate,newleavetype,subcompany,department);
        bb.writeLog("insertSql:"+sql);
    }

    /**
     * 判断是否存在月初1号的
     * @param resourceid
     * @param date
     * @return
     */
    private static Boolean checkNew(String resourceid,String date){
        RecordSet rs = new RecordSet();
        String sql = "select * from kq_format_total where resourceid = "+resourceid+" and kqdate = '"+date+"'";
        rs.execute(sql);
        Boolean check = false;
        if (rs.getCounts()>0){
            check = true;
        }
        return check;
    }

    /**
     * 插入考勤主表
     * @param userid
     * @param fromDate
     * @param yHours
     * @param groupid
     * @param sjHours
     */
    private static void insertKqTotal(Integer userid,String fromDate,Integer yHours,String groupid,Integer sjHours,Integer workdays){
        BaseBean bb  = new BaseBean();
        KQWorkTime kqWorkTime = new KQWorkTime();
        WorkTimeEntity tmpworkTime = kqWorkTime.getWorkTime(String.valueOf(userid), fromDate);
        //班组id
        String serialid  = tmpworkTime.getSerialId();
        RecordSet rs = new RecordSet();
        String sqlSe = "select subcompanyid1,departmentid,jobtitle from hrmresource where id = "+userid;
        rs.executeQuery(sqlSe);
        String subcompanyid = "";
        String departmentid = "";
        String jobtitle = "";
        if (rs.next()){
            subcompanyid = Util.null2String(rs.getString("subcompanyid1"));
            departmentid = Util.null2String(rs.getString("departmentid"));
            jobtitle = Util.null2String(rs.getString("jobtitle"));
        }
        bb.writeLog("subcompanyid:"+subcompanyid+"departmentid:"+departmentid+"jobtitle:"+jobtitle);

        RecordSet rsInsert = new RecordSet();
        String sql = "insert into kq_format_total (resourceid,kqdate,subcompanyid,departmentid,jobtitle,groupid,serialid,workdays,"
                + "workmins,attendancedays,attendancemins,signdays,signmins,belate,belatemins,gravebelate,gravebelatemins,leaveeearly," +
                "leaveearlymins,graveleaveearly,graveleaveearlymins,absenteeism,absenteeismmins,forgotcheck, forgotcheckMins,leaveMins,evectionMins,outMins)"+
                " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) ";
        rsInsert.executeUpdate(sql, userid,fromDate,subcompanyid,departmentid,jobtitle,groupid,serialid,workdays,
                yHours,0,sjHours,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
        bb.writeLog("insertSql:"+sql);
    }

    /**
     * 获取本月的天数
     * @param date
     * @return
     */
    private static int getDaysOfMonth(Date date) {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        return calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
    }

    /**
     * 获取当月事假时间（不包含节假日）
     * @param startTime
     * @param endTime
     * @return
     */
    private static String getSjTime(String startTime,String endTime,Integer resourceid,String type){
        RecordSet rs = new RecordSet();
        String sql = "select sum(d_mins) as leaveMins from  kq_flow_split_leave where newleavetype = '"+type+"' and  belongdate >= '"+startTime+"' and belongdate <= '"+endTime+"' and leavebackrequestid is null  and resourceid = "+resourceid;
        rs.executeQuery(sql);
        String 	leaveMins = "";
        if (rs.next()){
            leaveMins = Util.null2String(rs.getString("leaveMins"));
        }
        if (StringUtils.isBlank(leaveMins)){
            leaveMins = "0";
        }
        return leaveMins;
    }

    private static void insertOverTime(String requestid,String userid,String fromDate,Integer MaxHours,String changeType){
        BaseBean bb  = new BaseBean();
        //插入加班时间
        RecordSet rsInsert = new RecordSet();
        String uuid = UUID.randomUUID().toString();
        String sql = "insert into kq_flow_overtime (requestid,resourceid,fromdate,fromtime,todate,totime,duration_min,expiringdate,belongdate,"
                + "workMins,durationrule,changetype,paidLeaveEnable,computingMode,tiaoxiuId,uuid,fromdatedb,fromtimedb,todatedb,totimedb,flow_mins,card_mins,ori_belongdate,flow_dataid)"+
                " values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?) ";
        rsInsert.executeUpdate(sql, requestid,userid,fromDate,"07:30",fromDate,"18:00",MaxHours,"",fromDate,
                "","1",changeType,"0","3","-1",uuid,"","","","","0","0",fromDate,"");
        bb.writeLog("insertSql:"+sql);
    }

    /**
     * 获取当月加班时间（不包含节假日）
     * @param startTime
     * @param endTime
     * @return
     */
    private static String getOverTime(String startTime,String endTime,Integer resourceid){
        RecordSet rs = new RecordSet();
        BaseBean bb = new BaseBean();
        String sql = "select sum(duration_min) as duration_min from KQ_FLOW_OVERTIME where belongdate >= '"+startTime+"' and belongdate <= '"+endTime+"' and changetype <> 1 and resourceid = "+resourceid;
        rs.executeQuery(sql);
        bb.writeLog("sqlGetOverTime:"+sql);
        String 	duration_min = "";
        if (rs.next()){
            duration_min = Util.null2String(rs.getString("duration_min"));
        }
        if (StringUtils.isBlank(duration_min)){
            duration_min = "0";
        }
        return duration_min;
    }

    /**
     * 获取当月休息日
     * @param startTime
     * @param endTime
     * @return
     */
    private static String getXxDay(String startTime,String endTime,Integer groupId){
        BaseBean bb = new BaseBean();
        RecordSet rs = new RecordSet();
        String sql = "select holidayDate from  KQ_HolidaySet where  holidayDate >= '"+startTime+"' and holidayDate <= '"+endTime+"' and changeType in (1,3)  and groupId = "+groupId;
        rs.executeQuery(sql);
        List<Object> holidayList1 = new ArrayList<Object>();
        while (rs.next()){
            String holidayDate = Util.null2String(rs.getString("holidayDate"));
            holidayList1.add(holidayDate);
        }
        String sql2 = "select holidayDate from  KQ_HolidaySet where  holidayDate >= '"+startTime+"' and holidayDate <= '"+endTime+"' and changeType in (2)  and groupId = "+groupId;
        rs.executeQuery(sql2);
        List<Object> holidayList2 = new ArrayList<Object>();
        while (rs.next()){
            String holidayDate = Util.null2String(rs.getString("holidayDate"));
            holidayList2.add(holidayDate);
        }

        Calendar today = Calendar.getInstance();
        today.add(Calendar.MONTH, -1);
        String currentYear =  "" + today.get(Calendar.YEAR);
        String currentMonth = "" + today.get(Calendar.MONTH);
        Calendar dateTemp = Calendar.getInstance();
        Integer all = 0;
        for (int j = 1; j <= 31; j++) {
            dateTemp.clear();
            dateTemp.set(Integer.valueOf(currentYear),Integer.valueOf(currentMonth),j);
            if (dateTemp.get(Calendar.MONTH) != Integer.valueOf(currentMonth)) {//防止出现2月30号等错误日期参数
                continue;
            }
            String dateStr = Util.add0(dateTemp.get(Calendar.YEAR), 4) + "-" +
                    Util.add0(dateTemp.get(Calendar.MONTH) + 1, 2) + "-" +
                    Util.add0(dateTemp.get(Calendar.DAY_OF_MONTH), 2);
            if (holidayList1.contains(dateStr)) {
                all++;
            }else if(dateTemp.getTime().getDay() == 6 || dateTemp.getTime().getDay() == 0){
                if(!holidayList2.contains(dateStr)){
                    all++;
                }
            }
        }
        bb.writeLog("总休息天数:"+all);
        return String.valueOf(all);
    }


}
