package weaver.interfaces.omron.job;

import com.engine.kq.biz.KQOverTimeRuleCalBiz;
import com.wbi.util.StringUtil;
import weaver.common.DateUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * 历史考勤数据变更班次后重新计算加班时长定时任务
 */
public class NewOverTimeJob extends BaseCronJob {
    BaseBean basebean = new BaseBean();
    @Override
    public void execute() {

        try{
            basebean.writeLog("======================NewOverTimeJob Start======================");

            RecordSet rs = new RecordSet();

            Calendar calendar = Calendar.getInstance();
            calendar.set(Calendar.DAY_OF_MONTH, 1);
            Date firstDayOfMonthDate = calendar.getTime();

            //当前月的第一天
            String fromDate = cn.hutool.core.date.DateUtil.format(firstDayOfMonthDate,"yyyy-MM-dd");
            basebean.writeLog("fromDate: "+fromDate);
            //当前日期
            String toDate = cn.hutool.core.date.DateUtil.format(new Date(),"yyyy-MM-dd");
            basebean.writeLog("toDate: "+toDate);

            String eventtype = "历史考勤数据变更班次后重新计算加班时长";

            //获取考勤人员
            List<String> resourceIds = new ArrayList<>();
            String getResSql = "select id from hrmresource where status in (0,1,2,3)";
            basebean.writeLog("getResSql: "+getResSql);

            rs.executeQuery(getResSql);
            while (rs.next()) {
                String id = Util.null2String(rs.getString("id"));
                if (StringUtil.isNotBlank(id) ) {
                    resourceIds.add(id);
                }
            }
            basebean.writeLog("resourceIds: "+resourceIds);

            //根据人员循环执行
            for (String resourceid: resourceIds) {
                basebean.writeLog("===========人员重新计算加班start===========");
                basebean.writeLog("resourceid: "+resourceid);

                KQOverTimeRuleCalBiz kqOverTimeRuleCalBiz = new KQOverTimeRuleCalBiz();
                kqOverTimeRuleCalBiz.buildOvertime(resourceid, fromDate, toDate, eventtype);

            }


        }catch (Exception e){
            basebean.writeLog("NewOverTimeJob Exception: " + e);
            basebean.writeLog("加班生成数据报错:KQOverTimeRuleCalBiz:");
            StringWriter errorsWriter = new StringWriter();
            e.printStackTrace(new PrintWriter(errorsWriter));
            basebean.writeLog(errorsWriter.toString());
        }

        basebean.writeLog("======================NewOverTimeJob End======================");
    }

}
